diff -ruN vdr-1.7.16/osd.h vdr-1.7.17/osd.h
--- vdr-1.7.16/osd.h	2010-01-17 14:23:50.000000000 +0100
+++ vdr-1.7.17/osd.h	2011-03-12 17:06:48.000000000 +0100
@@ -323,9 +798,33 @@
        ///< a single color combination, and may not be able to serve all
        ///< requested colors. By default the palette assumes there will be
        ///< 10 fixed colors and 10 color combinations.
+       ///< If this is a true color OSD, this function does nothing.
   cBitmap *GetBitmap(int Area);
        ///< Returns a pointer to the bitmap for the given Area, or NULL if no
        ///< such bitmap exists.
+       ///< If this is a true color OSD, a pointer to a dummy bitmap with 8bpp
+       ///< is returned. This is done so that skins that call this function
+       ///< in order to preset the bitmap's palette won't crash.
+  virtual cPixmap *CreatePixmap(int Layer, const cRect &ViewPort, const cRect &DrawPort = cRect::Null);
+       ///< Creates a new true color pixmap on this OSD (see cPixmap for details).
+       ///< The caller must not delete the returned object, it will be deleted when
+       ///< the OSD is deleted. DestroyPixmap() can be called if a pixmap shall be
+       ///< destroyed before the OSD is deleted.
+       ///< If this is not a true color OSD, this function returns NULL.
+  virtual void DestroyPixmap(cPixmap *Pixmap);
+       ///< Destroys the given Pixmap, which has previously been created by a call to
+       ///< CreatePixmap(). When the OSD is deleted, all pixmaps are destroyed
+       ///< automatically. So this function only needs to be used if a pixmap shall
+       ///< be destroyed while the OSD is still being used.
+  virtual void DrawImage(const cPoint &Point, const cImage &Image);
+       ///< Draws the given Image on this OSD at the given Point.
+       ///< If this is not a true color OSD, this function does nothing.
+  virtual void DrawImage(const cPoint &Point, int ImageHandle);
+       ///< Draws the image referenced by the given ImageHandle on this OSD at
+       ///< the given Point. ImageHandle must be a value that has previously been
+       ///< returned by a call to cOsdProvider::StoreImage(). If ImageHandle
+       ///< has an invalid value, nothing happens.
+       ///< If this is not a true color OSD, this function does nothing.
   virtual eOsdError CanHandleAreas(const tArea *Areas, int NumAreas);
        ///< Checks whether the OSD can display the given set of sub-areas.
        ///< The return value indicates whether a call to SetAreas() with this
@@ -343,6 +842,9 @@
        ///< are part of the rectangle that surrounds a given drawing operation
        ///< will be drawn into, with the proper offsets.
        ///< A new call overwrites any previous settings
+       ///< To set up a true color OSD, exactly one area must be requested, with
+       ///< its coordinates set to the full area the OSD shall cover, and the
+       ///< bpp value set to 32.
   virtual void SaveRegion(int x1, int y1, int x2, int y2);
        ///< Saves the region defined by the given coordinates for later restoration
        ///< through RestoreRegion(). Only one saved region can be active at any
@@ -352,6 +854,7 @@
        ///< If SaveRegion() has not been called before, nothing will happen.
   virtual eOsdError SetPalette(const cPalette &Palette, int Area);
        ///< Sets the Palette for the given Area (the first area is numbered 0).
+       ///< If this is a true color OSD, nothing happens and oeOk is returned.
   virtual void DrawPixel(int x, int y, tColor Color);
        ///< Sets the pixel at the given coordinates to the given Color, which is
        ///< a full 32 bit ARGB value.
@@ -368,6 +871,7 @@
        ///< area shall have its palette replaced with the one from Bitmap.
        ///< If Overlay is true, any pixel in Bitmap that has color index 0 will
        ///< not overwrite the corresponding pixel in the target area.
+       ///< If this is a true color OSD, ReplacePalette has no meaning.
   virtual void DrawText(int x, int y, const char *s, tColor ColorFg, tColor ColorBg, const cFont *Font, int Width = 0, int Height = 0, int Alignment = taDefault);
        ///< Draws the given string at coordinates (x, y) with the given foreground
        ///< and background color and font. If Width and Height are given, the text
@@ -401,18 +905,51 @@
        ///< 7: vertical,   falling, upper
   virtual void Flush(void);
        ///< Actually commits all data to the OSD hardware.
+       ///< Flush() should return as soon as possible.
+       ///< For a true color OSD using the default implementation with in memory
+       ///< pixmaps, the Flush() function should basically do something like this:
+       ///<
+       ///<  LOCK_PIXMAPS;
+       ///<  while (cPixmapMemory *pm = RenderPixmaps()) {
+       ///<        int w = pm->ViewPort().Width();
+       ///<        int h = pm->ViewPort().Height();
+       ///<        int d = w * sizeof(tColor);
+       ///<        MyOsdDrawPixmap(Left() + pm->ViewPort().X(), Top() + pm->ViewPort().Y(), pm->Data(), w, h, h * d);
+       ///<        delete pm;
+       ///<        }
   };
 
+#define MAXOSDIMAGES 64
+
 class cOsdProvider {
+  friend class cPixmapMemory;
 private:
   static cOsdProvider *osdProvider;
   static int oldWidth;
   static int oldHeight;
   static double oldAspect;
+  static cImage *images[MAXOSDIMAGES];
 protected:
   virtual cOsd *CreateOsd(int Left, int Top, uint Level) = 0;
       ///< Returns a pointer to a newly created cOsd object, which will be located
       ///< at the given coordinates.
+  virtual bool ProvidesTrueColor(void) { return false; }
+      ///< Returns true if this OSD provider is able to handle a true color OSD.
+  virtual int StoreImageData(const cImage &Image);
+      ///< Copies the given Image and returns a handle for later reference.
+      ///< A derived class can implement its own image storing mechanism by
+      ///< reimplementing this function as well as DropImageData().
+      ///< The base class implementation simply copies the image data to allow
+      ///< plugins to always use this interface, no matter if the actual device
+      ///< provides support for storing image data or not. The handles returned
+      ///< by the default implementation are positive integers. A derived class
+      ///< might want to use negative integers as handles, so that it can fall
+      ///< back to using the base class image storing mechanism if, e.g.,  it runs
+      ///< out of memory.
+  virtual void DropImageData(int ImageHandle);
+      ///< Drops the image data referenced by ImageHandle.
+  static const cImage *GetImageData(int ImageHandle);
+      ///< Gets the image data referenced by ImageHandle.
 public:
   cOsdProvider(void);
       //XXX maybe parameter to make this one "sticky"??? (frame-buffer etc.)
@@ -427,7 +964,22 @@
       ///< Inquires the actual size of the video display and adjusts the OSD and
       ///< font sizes accordingly. If Force is true, all settings are recalculated,
       ///< even if the video resolution hasn't changed since the last call to
-      ///< this funtion.
+      ///< this function.
+  static bool SupportsTrueColor(void);
+      ///< Returns true if the current OSD provider is able to handle a true color OSD.
+  static int StoreImage(const cImage &Image);
+      ///< Stores the given Image for later use with DrawImage() on an OSD or
+      ///< pixmap. The returned number is a handle that must be used when
+      ///< referencing this image in a call to DrawImage() or DropImage().
+      ///< The image data is copied, so any later changes to Image will have
+      ///< no effect on the stored image.
+      ///< A derived class may be able to copy frequently used images to some
+      ///< space where they can be retrieved faster than using a cImage in each call.
+      ///< If this is not a true color OSD, or if the image data can't be stored for
+      ///< any reason, this function returns 0 and nothing is stored.
+  static void DropImage(int ImageHandle);
+      ///< Drops the image referenced by the given ImageHandle. If ImageHandle
+      ///< has an invalid value, nothing happens.
   static void Shutdown(void);
       ///< Shuts down the OSD provider facility by deleting the current OSD provider.
   };
diff -ruN vdr-1.7.16/osdbase.c vdr-1.7.17/osdbase.c
--- vdr-1.7.16/osdbase.c	2010-01-17 12:36:12.000000000 +0100
+++ vdr-1.7.17/osdbase.c	2010-12-12 14:41:28.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: osdbase.c 2.2 2010/01/17 11:36:12 kls Exp $
+ * $Id: osdbase.c 2.3 2010/12/12 13:41:28 kls Exp $
  */
 
 #include "osdbase.h"
@@ -500,7 +500,7 @@
         return state;
         }
      }
-  switch (Key) {
+  switch (int(Key)) {
     case k0:      return osUnknown;
     case k1...k9: return hasHotkeys ? HotKey(Key) : osUnknown;
     case kUp|k_Repeat:
diff -ruN vdr-1.7.16/pat.c vdr-1.7.17/pat.c
--- vdr-1.7.16/pat.c	2010-06-13 13:12:12.000000000 +0200
+++ vdr-1.7.17/pat.c	2010-11-07 14:47:16.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: pat.c 2.13 2010/06/13 11:12:12 kls Exp $
+ * $Id: pat.c 2.15 2010/11/07 13:47:16 kls Exp $
  */
 
 #include "pat.h"
@@ -456,29 +456,51 @@
                          }
                       }
                       break;
-              case 0x81: // STREAMTYPE_USER_PRIVATE
-                      if (Channel->IsAtsc()) { // ATSC AC-3
-                         char lang[MAXLANGCODE1] = { 0 };
-                         SI::Descriptor *d;
-                         for (SI::Loop::Iterator it; (d = stream.streamDescriptors.getNext(it)); ) {
-                             switch (d->getDescriptorTag()) {
-                               case SI::ISO639LanguageDescriptorTag: {
-                                    SI::ISO639LanguageDescriptor *ld = (SI::ISO639LanguageDescriptor *)d;
-                                    strn0cpy(lang, I18nNormalizeLanguageCode(ld->languageCode), MAXLANGCODE1);
-                                    }
-                                    break;
-                               default: ;
-                               }
-                             delete d;
-                             }
-                         if (NumDpids < MAXDPIDS) {
-                            Dpids[NumDpids] = esPid;
-                            Dtypes[NumDpids] = SI::AC3DescriptorTag;
-                            strn0cpy(DLangs[NumDpids], lang, MAXLANGCODE1);
-                            NumDpids++;
+              case 0x80 ... 0xFF: // STREAMTYPE_USER_PRIVATE
+                      {
+                      char lang[MAXLANGCODE1] = { 0 };
+                      bool IsAc3 = false;
+                      SI::Descriptor *d;
+                      for (SI::Loop::Iterator it; (d = stream.streamDescriptors.getNext(it)); ) {
+                          switch (d->getDescriptorTag()) {
+                            case SI::RegistrationDescriptorTag: {
+                                 SI::RegistrationDescriptor *rd = (SI::RegistrationDescriptor *)d;
+                                 // http://www.smpte-ra.org/mpegreg/mpegreg.html
+                                 switch (rd->getFormatIdentifier()) {
+                                   case 0x44434949: // 'DCII' aka. DigiCipher II
+                                        Vpid = esPid;
+                                        Ppid = pmt.getPCRPid();
+                                        Vtype = 0x02; // DCII compression is based upon MPEG-2
+                                        ProcessCaDescriptors = true;
+                                        break;
+                                   case 0x41432D33: // 'AC-3'
+                                        IsAc3 = true;
+                                        break;
+                                   default:
+                                        //printf("Format identifier: 0x08X\n", rd->getFormatIdentifier());
+                                        break;
+                                   }
+                                 }
+                                 break;
+                            case SI::ISO639LanguageDescriptorTag: {
+                                 SI::ISO639LanguageDescriptor *ld = (SI::ISO639LanguageDescriptor *)d;
+                                 strn0cpy(lang, I18nNormalizeLanguageCode(ld->languageCode), MAXLANGCODE1);
+                                 }
+                                 break;
+                            default: ;
                             }
+                         delete d;
+                         }
+                      if (IsAc3) {
+                         if (NumDpids < MAXDPIDS) {
+                           Dpids[NumDpids] = esPid;
+                           Dtypes[NumDpids] = SI::AC3DescriptorTag;
+                           strn0cpy(DLangs[NumDpids], lang, MAXLANGCODE1);
+                           NumDpids++;
+                           }
                          ProcessCaDescriptors = true;
                          }
+                      }
                       break;
               default: ;//printf("PID: %5d %5d %2d %3d %3d\n", pmt.getServiceId(), stream.getPid(), stream.getStreamType(), pmt.getVersionNumber(), Channel->Number());
               }
diff -ruN vdr-1.7.16/receiver.c vdr-1.7.17/receiver.c
--- vdr-1.7.16/receiver.c	2010-02-28 15:25:32.000000000 +0100
+++ vdr-1.7.17/receiver.c	2010-12-13 00:16:25.000000000 +0100
@@ -4,11 +4,10 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: receiver.c 2.3 2010/02/28 14:25:32 kls Exp $
+ * $Id: receiver.c 2.4 2010/12/12 23:16:25 kls Exp $
  */
 
 #include "receiver.h"
-#include <stdarg.h>
 #include <stdio.h>
 #include "tools.h"
 
diff -ruN vdr-1.7.16/recorder.c vdr-1.7.17/recorder.c
--- vdr-1.7.16/recorder.c	2010-01-29 17:37:22.000000000 +0100
+++ vdr-1.7.17/recorder.c	2010-12-27 12:35:46.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recorder.c 2.8 2010/01/29 16:37:22 kls Exp $
+ * $Id: recorder.c 2.9 2010/12/27 11:35:46 kls Exp $
  */
 
 #include "recorder.h"
@@ -24,8 +24,9 @@
 cRecorder::cRecorder(const char *FileName, const cChannel *Channel, int Priority)
 :cReceiver(Channel, Priority)
 ,cThread("recording")
-,recordingInfo(FileName)
 {
+  recordingName = strdup(FileName);
+
   // Make sure the disk is up and running:
 
   SpinUpDisk(FileName);
@@ -69,6 +70,7 @@
   delete fileName;
   delete frameDetector;
   delete ringBuffer;
+  free(recordingName);
 }
 
 bool cRecorder::RunningLowOnDiskSpace(void)
@@ -127,10 +129,12 @@
                  break;
               if (frameDetector->Synced()) {
                  if (!InfoWritten) {
-                    if (recordingInfo.Read()) {
-                       if (frameDetector->FramesPerSecond() > 0 && !DoubleEqual(recordingInfo.FramesPerSecond(), frameDetector->FramesPerSecond())) {
-                          recordingInfo.SetFramesPerSecond(frameDetector->FramesPerSecond());
-                          recordingInfo.Write();
+                    cRecordingInfo RecordingInfo(recordingName);
+                    if (RecordingInfo.Read()) {
+                       if (frameDetector->FramesPerSecond() > 0 && !DoubleEqual(RecordingInfo.FramesPerSecond(), frameDetector->FramesPerSecond())) {
+                          RecordingInfo.SetFramesPerSecond(frameDetector->FramesPerSecond());
+                          RecordingInfo.Write();
+                          Recordings.UpdateByName(recordingName);
                           }
                        }
                     InfoWritten = true;
diff -ruN vdr-1.7.16/recorder.h vdr-1.7.17/recorder.h
--- vdr-1.7.16/recorder.h	2010-01-29 17:32:32.000000000 +0100
+++ vdr-1.7.17/recorder.h	2010-12-27 12:17:04.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recorder.h 2.2 2010/01/29 16:32:32 kls Exp $
+ * $Id: recorder.h 2.3 2010/12/27 11:17:04 kls Exp $
  */
 
 #ifndef __RECORDER_H
@@ -24,7 +24,7 @@
   cFileName *fileName;
   cIndexFile *index;
   cUnbufferedFile *recordFile;
-  cRecordingInfo recordingInfo;
+  char *recordingName;
   off_t fileSize;
   time_t lastDiskSpaceCheck;
   bool RunningLowOnDiskSpace(void);
diff -ruN vdr-1.7.16/recording.c vdr-1.7.17/recording.c
--- vdr-1.7.16/recording.c	2010-03-07 15:06:04.000000000 +0100
+++ vdr-1.7.17/recording.c	2011-02-27 14:35:20.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recording.c 2.23 2010/03/07 14:06:04 kls Exp $
+ * $Id: recording.c 2.26 2011/02/27 13:35:20 kls Exp $
  */
 
 #include "recording.h"
@@ -57,6 +57,7 @@
 #define DELETEDLIFETIME   300 // seconds after which a deleted recording will be actually removed
 #define DISKCHECKDELTA    100 // seconds between checks for free disk space
 #define REMOVELATENCY      10 // seconds to wait until next check after removing a file
+#define MARKSUPDATEDELTA   10 // seconds between checks for updating editing marks
 
 #define MAX_SUBTITLE_LENGTH  40
 
@@ -548,13 +549,17 @@
                      default:
                        if (strchr(InvalidChars, *p) || *p == '.' && (!*(p + 1) || *(p + 1) == FOLDERDELIMCHAR)) { // Windows can't handle '.' at the end of file/directory names
                           int l = p - s;
-                          s = (char *)realloc(s, strlen(s) + 10);
-                          p = s + l;
-                          char buf[4];
-                          sprintf(buf, "#%02X", (unsigned char)*p);
-                          memmove(p + 2, p, strlen(p) + 1);
-                          strncpy(p, buf, 3);
-                          p += 2;
+                          if (char *NewBuffer = (char *)realloc(s, strlen(s) + 10)) {
+                             s = NewBuffer;
+                             p = s + l;
+                             char buf[4];
+                             sprintf(buf, "#%02X", (unsigned char)*p);
+                             memmove(p + 2, p, strlen(p) + 1);
+                             strncpy(p, buf, 3);
+                             p += 2;
+                             }
+                          else
+                             esyslog("ERROR: out of memory");
                           }
                      }
               }
@@ -678,7 +683,7 @@
   const char *p = strrchr(FileName, '/');
 
   name = NULL;
-  info = new cRecordingInfo;
+  info = new cRecordingInfo(fileName);
   if (p) {
      time_t now = time(NULL);
      struct tm tm_r;
@@ -729,9 +734,13 @@
                     if (data[line]) {
                        int len = strlen(s);
                        len += strlen(data[line]) + 1;
-                       data[line] = (char *)realloc(data[line], len + 1);
-                       strcat(data[line], "\n");
-                       strcat(data[line], s);
+                       if (char *NewBuffer = (char *)realloc(data[line], len + 1)) {
+                          data[line] = NewBuffer;
+                          strcat(data[line], "\n");
+                          strcat(data[line], s);
+                          }
+                       else
+                          esyslog("ERROR: out of memory");
                        }
                     else
                        data[line] = strdup(s);
@@ -750,12 +759,16 @@
               // line 1 and line 2 to be the long text:
               int len = strlen(data[1]);
               if (len > 80) {
-                 data[1] = (char *)realloc(data[1], len + 1 + strlen(data[2]) + 1);
-                 strcat(data[1], "\n");
-                 strcat(data[1], data[2]);
-                 free(data[2]);
-                 data[2] = data[1];
-                 data[1] = NULL;
+                 if (char *NewBuffer = (char *)realloc(data[1], len + 1 + strlen(data[2]) + 1)) {
+                    data[1] = NewBuffer;
+                    strcat(data[1], "\n");
+                    strcat(data[1], data[2]);
+                    free(data[2]);
+                    data[2] = data[1];
+                    data[1] = NULL;
+                    }
+                 else
+                    esyslog("ERROR: out of memory");
                  }
               }
            info->SetData(data[0], data[1], data[2]);
@@ -921,6 +934,14 @@
   return *s == '%';
 }
 
+void cRecording::ReadInfo(void)
+{
+  info->Read();
+  priority = info->priority;
+  lifetime = info->lifetime;
+  framesPerSecond = info->framesPerSecond;
+}
+
 bool cRecording::WriteInfo(void)
 {
   cString InfoFileName = cString::sprintf("%s%s", fileName, isPesRecording ? INFOFILESUFFIX ".vdr" : INFOFILESUFFIX);
@@ -1172,6 +1193,14 @@
      }
 }
 
+void cRecordings::UpdateByName(const char *FileName)
+{
+  LOCK_THREAD;
+  cRecording *recording = GetByName(FileName);
+  if (recording)
+     recording->ReadInfo();
+}
+
 int cRecordings::TotalFileSizeMB(void)
 {
   int size = 0;
@@ -1239,12 +1268,28 @@
 
 bool cMarks::Load(const char *RecordingFileName, double FramesPerSecond, bool IsPesRecording)
 {
-  cMutexLock MutexLock(&MutexMarkFramesPerSecond);
+  fileName = AddDirectory(RecordingFileName, IsPesRecording ? MARKSFILESUFFIX ".vdr" : MARKSFILESUFFIX);
   framesPerSecond = FramesPerSecond;
-  MarkFramesPerSecond = framesPerSecond;
-  if (cConfig<cMark>::Load(AddDirectory(RecordingFileName, IsPesRecording ? MARKSFILESUFFIX ".vdr" : MARKSFILESUFFIX))) {
-     Sort();
-     return true;
+  lastUpdate = 0;
+  lastFileTime = -1; // the first call to Load() must take place!
+  return Update();
+}
+
+bool cMarks::Update(void)
+{
+  time_t t = time(NULL);
+  if (t - lastUpdate > MARKSUPDATEDELTA) {
+     lastUpdate = t;
+     t = LastModifiedTime(fileName);
+     if (t > lastFileTime) {
+        lastFileTime = t;
+        cMutexLock MutexLock(&MutexMarkFramesPerSecond);
+        MarkFramesPerSecond = framesPerSecond;
+        if (cConfig<cMark>::Load(fileName)) {
+           Sort();
+           return true;
+           }
+        }
      }
   return false;
 }
@@ -1604,13 +1649,15 @@
                }
             int newLast = int(buf.st_size / sizeof(tIndexTs) - 1);
             if (newLast > last) {
-               if (size <= newLast) {
-                  size *= 2;
-                  if (size <= newLast)
-                     size = newLast + 1;
+               int NewSize = size;
+               if (NewSize <= newLast) {
+                  NewSize *= 2;
+                  if (NewSize <= newLast)
+                     NewSize = newLast + 1;
                   }
-               index = (tIndexTs *)realloc(index, size * sizeof(tIndexTs));
-               if (index) {
+               if (tIndexTs *NewBuffer = (tIndexTs *)realloc(index, NewSize * sizeof(tIndexTs))) {
+                  size = NewSize;
+                  index = NewBuffer;
                   int offset = (last + 1) * sizeof(tIndexTs);
                   int delta = (newLast - last) * sizeof(tIndexTs);
                   if (lseek(f, offset, SEEK_SET) == offset) {
@@ -1629,8 +1676,10 @@
                   else
                      LOG_ERROR_STR(fileName);
                   }
-               else
+               else {
                   esyslog("ERROR: can't realloc() index");
+                  break;
+                  }
                }
             }
          else
diff -ruN vdr-1.7.16/recording.h vdr-1.7.17/recording.h
--- vdr-1.7.16/recording.h	2010-03-07 15:06:15.000000000 +0100
+++ vdr-1.7.17/recording.h	2011-02-27 13:48:21.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recording.h 2.14 2010/03/07 14:06:15 kls Exp $
+ * $Id: recording.h 2.16 2011/02/27 12:48:21 kls Exp $
  */
 
 #ifndef __RECORDING_H
@@ -117,6 +117,7 @@
   bool IsNew(void) const { return GetResume() <= 0; }
   bool IsEdited(void) const;
   bool IsPesRecording(void) const { return isPesRecording; }
+  void ReadInfo(void);
   bool WriteInfo(void);
   bool Delete(void);
        // Changes the file name so that it will no longer be visible in the "Recordings" menu
@@ -165,6 +166,7 @@
   cRecording *GetByName(const char *FileName);
   void AddByName(const char *FileName, bool TriggerUpdate = true);
   void DelByName(const char *FileName);
+  void UpdateByName(const char *FileName);
   int TotalFileSizeMB(void); ///< Only for deleted recordings!
   };
 
@@ -188,9 +190,13 @@
 
 class cMarks : public cConfig<cMark> {
 private:
+  cString fileName;
   double framesPerSecond;
+  time_t lastUpdate;
+  time_t lastFileTime;
 public:
   bool Load(const char *RecordingFileName, double FramesPerSecond = DEFAULTFRAMESPERSECOND, bool IsPesRecording = false);
+  bool Update(void);
   void Sort(void);
   cMark *Add(int Position);
   cMark *Get(int Position);
diff -ruN vdr-1.7.16/remote.c vdr-1.7.17/remote.c
--- vdr-1.7.16/remote.c	2009-12-06 13:08:03.000000000 +0100
+++ vdr-1.7.17/remote.c	2010-12-24 16:26:05.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: remote.c 2.1 2009/12/06 12:08:03 kls Exp $
+ * $Id: remote.c 2.2 2010/12/24 15:26:05 kls Exp $
  */
 
 #include "remote.h"
@@ -42,6 +42,7 @@
 
 cRemote::~cRemote()
 {
+  Remotes.Del(this, false);
   free(name);
 }
 
diff -ruN vdr-1.7.16/remux.c vdr-1.7.17/remux.c
--- vdr-1.7.16/remux.c	2010-06-05 15:32:15.000000000 +0200
+++ vdr-1.7.17/remux.c	2011-02-26 16:51:04.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: remux.c 2.47 2010/06/05 13:32:15 kls Exp $
+ * $Id: remux.c 2.51 2011/02/26 15:51:04 kls Exp $
  */
 
 #include "remux.h"
@@ -225,7 +225,7 @@
       Target[i++] = *Language++;
       Target[i++] = *Language++;
       Target[i++] = *Language++;
-      Target[i++] = 0x01;     // audio type
+      Target[i++] = 0x00;     // audio type
       Target[Length] += 0x04; // length
       if (*Language == '+')
          Language++;
@@ -666,9 +666,13 @@
      return; // skip everything before the first payload start
   Length = TsGetPayload(&Data);
   if (length + Length > size) {
-     size = max(KILOBYTE(2), length + Length);
-     data = (uchar *)realloc(data, size);
-     if (!data) {
+     int NewSize = max(KILOBYTE(2), length + Length);
+     if (uchar *NewData = (uchar *)realloc(data, NewSize)) {
+        data = NewData;
+        size = NewSize;
+        }
+     else {
+        esyslog("ERROR: out of memory");
         Reset();
         return;
         }
@@ -780,9 +784,8 @@
   newFrame = independentFrame = false;
   numPtsValues = 0;
   numIFrames = 0;
-  frameDuration = 0;
+  framesPerSecond = 0;
   framesInPayloadUnit = framesPerPayloadUnit = 0;
-  payloadUnitOfFrame = 0;
   scanning = false;
   scanner = EMPTY_SCANNER;
 }
@@ -804,7 +807,6 @@
 void cFrameDetector::Reset(void)
 {
   newFrame = independentFrame = false;
-  payloadUnitOfFrame = 0;
   scanning = false;
   scanner = EMPTY_SCANNER;
 }
@@ -831,8 +833,8 @@
                     return Processed;
                  if (Length < MIN_TS_PACKETS_FOR_FRAME_DETECTOR * TS_SIZE)
                     return Processed; // need more data, in case the frame type is not stored in the first TS packet
-                 if (!frameDuration) {
-                    // frame duration unknown, so collect a sequence of PTS values:
+                 if (!framesPerSecond) {
+                    // frame rate unknown, so collect a sequence of PTS values:
                     if (numPtsValues < MaxPtsValues && numIFrames < 2) { // collect a sequence containing at least two I-frames
                        const uchar *Pes = Data + TsPayloadOffset(Data);
                        if (PesHasPts(Pes)) {
@@ -857,28 +859,22 @@
                        uint32_t Delta = ptsValues[0];
                        // determine frame info:
                        if (isVideo) {
-                          if (Delta % 3600 == 0)
-                             frameDuration = 3600; // PAL, 25 fps, exact timing
-                          else if (abs(Delta % 3600) == 3599 || abs(Delta % 3600) == 1)
-                             frameDuration = 3600; // PAL, 25 fps, timing with jitter
+                          if (abs(Delta - 3600) <= 1)
+                             framesPerSecond = 25.0;
                           else if (Delta % 3003 == 0)
-                             frameDuration = 3003; // NTSC, 29.97 fps
-                          else if (abs(Delta - 1800) <= 1) {
-                             frameDuration = 3600; // PAL, 25 fps
-                             framesPerPayloadUnit = -2;
-                             }
-                          else if (Delta == 1501) {
-                             frameDuration = 3003; // NTSC, 29.97 fps
-                             framesPerPayloadUnit = -2;
-                             }
+                             framesPerSecond = 30.0 / 1.001;
+                          else if (abs(Delta - 1800) <= 1)
+                             framesPerSecond = 50.0;
+                          else if (Delta == 1501)
+                             framesPerSecond = 60.0 / 1.001;
                           else {
-                             frameDuration = 3600; // unknown, assuming 25 fps
-                             dsyslog("unknown frame duration (%d), assuming 25 fps", Delta);
+                             framesPerSecond = 25.0;
+                             dsyslog("unknown frame delta (%d), assuming 25 fps", Delta);
                              }
                           }
                        else // audio
-                          frameDuration = Delta; // PTS of audio frames is always increasing
-                       dbgframes("\nframe duration = %d  FPS = %5.2f  FPPU = %d\n", frameDuration, 90000.0 / frameDuration, framesPerPayloadUnit);
+                          framesPerSecond = 90000.0 / Delta; // PTS of audio frames is always increasing
+                       dbgframes("\nDelta = %d  FPS = %5.2f  FPPU = %d\n", Delta, framesPerSecond, framesPerPayloadUnit);
                        }
                     }
                  scanner = EMPTY_SCANNER;
@@ -927,13 +923,6 @@
                                newFrame = true;
                                independentFrame = Data[i + 1] == 0x10;
                                if (synced) {
-                                  if (framesPerPayloadUnit < 0) {
-                                     payloadUnitOfFrame = (payloadUnitOfFrame + 1) % -framesPerPayloadUnit;
-                                     if (payloadUnitOfFrame != 0 && independentFrame)
-                                        payloadUnitOfFrame = 0;
-                                     if (payloadUnitOfFrame)
-                                        newFrame = false;
-                                     }
                                   if (framesPerPayloadUnit <= 1)
                                      scanning = false;
                                   }
@@ -964,7 +953,7 @@
                                 pid = 0; // let's just ignore any further data
                        }
                      }
-                 if (!synced && frameDuration && independentFrame) {
+                 if (!synced && framesPerSecond && independentFrame) {
                     synced = true;
                     dbgframes("*");
                     Reset();
